#include "buffer.h"


void bufDisplay(BUF *buffer)
{
  memcpy(SCREEN_BASE_ADDRESS,buffer,SCR_SIZE);
}

void bufFill(BUF *buffer,int color)
{
  memset(buffer,color,SCR_SIZE);
}

void bufSetPixel(BUF *buffer,int x,int y,int color)
{
  int pos=y*160+x/2;
  BUF px=buffer[pos];
  if(x%2==1)
  {
    buffer[pos]=((px>>4)<<4)+color;
  }
  else
  {
    buffer[pos]=(px>>4)+(color<<4);
  }
}

void securedBufSetPixel(BUF *buffer,int x,int y,int color)
{
  if(x>=0 && x<320 && y>=0 && y<240)
  {
    int pos=y*160+x/2;
    BUF px=buffer[pos];
    if(x%2==1)
    {
      buffer[pos]=((px>>4)<<4)+color;
    }
    else
    {
      buffer[pos]=(px>>4)+(color<<4);
    }
  }
}

void bufHorizLine(BUF *buffer,int x,int y,int x2, int color)
{
  int width=0;
  if(x>x2)
    invertVars(&x,&x2);
  if(x2>=0 && x<320 && y>=0 && y<240)
  {
    if(x<0)
      x=0;
    if(x2>319)
      x2=319;
    if(x%2==1)
    {
      bufSetPixel(buffer,x,y,color);
      x+=1;
    }
    width=x2-x+1;
    if(width%2==1)
    {
      bufSetPixel(buffer,x2,y,color);
      x2-=1;
    }
    width=x2-x+1;
    if(width/2>0)
      memset(buffer+(y*320+x)/2,(color<<4)+color,width/2);
  }
}

