#ifndef _DRAW_H_
#define _DRAW_H_

#include "buffer.h"
#include "3D.h"

//Clipped triangle filling
void drawTriangle(BUF *buffer,int color,int x1,int y1,int x2,int y2,int x3,int y3);

//Test if a cube is on the screen. (used by drawCube)
int isCubeOnScreen(int *pos);

//Cube drawing
//vertices should be a table of size 3*8    {x1,y1,z1, x2,y2,z2,...}
//pos should be a table of size 2*8    {x1,y1, x2,y2,...}
//faces should be a table of size 4*6    {v1,v2,v3,v4, v1,v2,v5,v6,...}
//colors should be a table of size 1*6    {c1, c2, c3,...}
void drawCube(BUF *buffer,double *vertices,int *pos,int *faces,int *colors);

#endif
